-- License CC0 (Creative Commons license) (c) darkfrei, 2022

--love.window.setMode(1280, 800)

local function getColorHEX(rgba)
--	setColorHEX(rgba)
--	where rgba = "#336699cc"
	local rb = tonumber(string.sub(rgba, 2, 3), 16) 
	local gb = tonumber(string.sub(rgba, 4, 5), 16) 
	local bb = tonumber(string.sub(rgba, 6, 7), 16)
	local ab = tonumber(string.sub(rgba, 8, 9), 16) or nil
	print (rb, gb, bb, ab)
	return {love.math.colorFromBytes( rb, gb, bb, ab )}
end

local backgroundColor = getColorHEX("#84C1EE") -- 132/255	193/255	238/255

local function updateCurtainCanvas (x, y, radius)
	love.graphics.setCanvas (CurtainCanvas)
		love.graphics.setBlendMode( "alpha")
		love.graphics.setColor (0,0,0,1) -- black
		love.graphics.rectangle ('fill', 0,0, CurtainCanvas:getWidth( ), CurtainCanvas:getHeight( ))
		
		-- circle
		love.graphics.setBlendMode( "replace")
		love.graphics.setColor (1,1,1,0)
		love.graphics.circle ('fill', x, y, radius)
		
	love.graphics.setCanvas ()
end

function love.load()
	local backgroundColor = getColorHEX("#84C1EE")
	love.graphics.setBackgroundColor(backgroundColor)
	
	CurtainCanvas = love.graphics.newCanvas ()
	
	updateCurtainCanvas (100, 100, 100)
end

 
function love.update(dt)
	
end


function love.draw()
	love.graphics.setColor (1,1,1)
	love.graphics.setBlendMode("alpha")
	love.graphics.rectangle('fill', 100, 150, 350, 250)
	
	-- and than curtain
	love.graphics.draw(CurtainCanvas)
end

function love.keypressed(key, scancode, isrepeat)
	if false then
	elseif key == "escape" then
		love.event.quit()
	end
end

function love.mousemoved( x, y, dx, dy, istouch )
	updateCurtainCanvas (x, y, math.min (x, y))
end
